<?php

declare(strict_types=1);

/*
 * This file is part of the TYPO3 CMS project.
 *
 * It is free software; you can redistribute it and/or modify it under
 * the terms of the GNU General Public License, either version 2
 * of the License, or any later version.
 *
 * For the full copyright and license information, please read the
 * LICENSE.txt file that was distributed with this source code.
 *
 * The TYPO3 project - inspiring people to share!
 */

namespace TYPO3\CMS\Styleguide\TcaDataGenerator\FieldGenerator;

use TYPO3\CMS\Styleguide\TcaDataGenerator\FieldGeneratorInterface;

/**
 * Generate data for type=select fields with foreign_table=tx_styleguide_staticdata and MM
 *
 * @internal
 */
final class TypeSelectStaticData extends AbstractFieldGenerator implements FieldGeneratorInterface
{
    protected $matchArray = [
        'fieldConfig' => [
            'config' => [
                'type' => 'select',
                'foreign_table' => 'tx_styleguide_staticdata',
            ],
        ],
    ];

    public function generate(array $data): string
    {
        // "Parent count" field - just use zero as string here.
        return '0';
    }
}
